/*
 * PartialChargesMap.hpp
 *
 *  Created on: Jun 12, 2016
 *      Author: heber
 */


#ifndef PARTIALCHARGESMAP_HPP_
#define PARTIALCHARGESMAP_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <boost/fusion/container/map.hpp>
#include <boost/mpl/list.hpp>

#include "Fragmentation/Summation/Containers/PartialChargesFused.hpp"

class IndexedPartialCharges;

/** This boost::fusion map defines key-value or rather key-type pairs with
 * which we associate all forces data members in MPQCData and their type.
 *
 * This lets us resolves any ambiguitites of types in MPQCData, e.g.
 * to know vector<double> is forces or energy_eigenvalues.
 *
 */
typedef boost::fusion::map<
  boost::fusion::pair<PartialChargesFused::partial_charges_t, IndexedPartialCharges >
> PartialChargesMap_t;

typedef boost::mpl::list<
    PartialChargesFused::partial_charges_t
> PartialChargesVector_t;

#endif /* PARTIALCHARGESMAP_HPP_ */
